# coding: utf-8

"""
    Gemma RESTful API

    This website documents the usage of the [Gemma RESTful API](https://gemma.msl.ubc.ca/rest/v2/). Here you can find example script usage of the API, as well as graphical interface for each endpoint, with description of its parameters and the endpoint URL.  Use of this webpage and the Gemma Web services, including the REST API, is subject to [these terms and conditions](https://pavlidislab.github.io/Gemma/terms.html). Please read these in full before continuing to use this webpage or any other part of the Gemma system.  You can [consult the CHANGELOG.md file](https://gemma.msl.ubc.ca/resources/restapidocs/CHANGELOG.md) to view  release notes and recent changes to the Gemma RESTful API.   # noqa: E501

    OpenAPI spec version: 2.8.0
    Contact: pavlab-support@msl.ubc.ca
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class ResponseErrorObject(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'error': 'WellComposedErrorBody',
        'api_version': 'str',
        'build_info': 'BuildInfoValueObject'
    }

    attribute_map = {
        'error': 'error',
        'api_version': 'apiVersion',
        'build_info': 'buildInfo'
    }

    def __init__(self, error=None, api_version=None, build_info=None):  # noqa: E501
        """ResponseErrorObject - a model defined in Swagger"""  # noqa: E501
        self._error = None
        self._api_version = None
        self._build_info = None
        self.discriminator = None
        if error is not None:
            self.error = error
        if api_version is not None:
            self.api_version = api_version
        if build_info is not None:
            self.build_info = build_info

    @property
    def error(self):
        """Gets the error of this ResponseErrorObject.  # noqa: E501


        :return: The error of this ResponseErrorObject.  # noqa: E501
        :rtype: WellComposedErrorBody
        """
        return self._error

    @error.setter
    def error(self, error):
        """Sets the error of this ResponseErrorObject.


        :param error: The error of this ResponseErrorObject.  # noqa: E501
        :type: WellComposedErrorBody
        """

        self._error = error

    @property
    def api_version(self):
        """Gets the api_version of this ResponseErrorObject.  # noqa: E501


        :return: The api_version of this ResponseErrorObject.  # noqa: E501
        :rtype: str
        """
        return self._api_version

    @api_version.setter
    def api_version(self, api_version):
        """Sets the api_version of this ResponseErrorObject.


        :param api_version: The api_version of this ResponseErrorObject.  # noqa: E501
        :type: str
        """

        self._api_version = api_version

    @property
    def build_info(self):
        """Gets the build_info of this ResponseErrorObject.  # noqa: E501


        :return: The build_info of this ResponseErrorObject.  # noqa: E501
        :rtype: BuildInfoValueObject
        """
        return self._build_info

    @build_info.setter
    def build_info(self, build_info):
        """Sets the build_info of this ResponseErrorObject.


        :param build_info: The build_info of this ResponseErrorObject.  # noqa: E501
        :type: BuildInfoValueObject
        """

        self._build_info = build_info

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(ResponseErrorObject, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ResponseErrorObject):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
